﻿Imports System.Text
Public Class ClassBinaryExpression

    Enum enumOperatorTypes
        enumNone = 0
        enumAdd = 1
        enumSubtract = 2
        enumMult = 3
        enumDivide = 4
        enumPower = 5
        enumApplyFunction = 6
    End Enum

    Private _operatorStr As String = ""
    Private _firstvar As ClassVarOrVal
    Private _priority As Double
    Private _operator As enumOperatorTypes
    Private _leftchildnodelist As List(Of ClassBinaryExpression)

    Public Function TranslateOperator(ByVal enumarg As enumOperatorTypes) As String
        Select Case enumarg
            Case enumOperatorTypes.enumAdd
                Return "add"
            Case enumOperatorTypes.enumApplyFunction
                Return "apply function"
            Case enumOperatorTypes.enumDivide
                Return "divide"
            Case enumOperatorTypes.enumMult
                Return "multiply"
            Case enumOperatorTypes.enumNone
                Return "none"
            Case enumOperatorTypes.enumPower
                Return "raise to power"
            Case enumOperatorTypes.enumSubtract
                Return "subtract"
            Case Else
                Return "unknown"
        End Select
    End Function

    Public Function PrintSelf() As String
        Dim sb As New StringBuilder("[")
        sb.Append("Tipo " & _firstvar.pKindAsStr)
        If _firstvar.pKind = ClassVarOrVal.enumvarOrVal.node Or _firstvar.pKind = ClassVarOrVal.enumvarOrVal.Variable _
            Or _firstvar.pKind = ClassVarOrVal.enumvarOrVal.efunction Then
            sb.Append(" pStr=" & _firstvar.pStr)
        End If
        sb.Append(" valor é : " & _firstvar.pValue)
        If _operatorStr.Length = 0 Then
            sb.Append("; operator=( NONE );")
        Else
            sb.Append("; operator=( " & _operatorStr & " );")
        End If

        sb.Append(" prioridade " & _priority)
        sb.AppendLine("]")
        Return sb.ToString
    End Function
    Public Function CopySelf() As ClassBinaryExpression
        Dim clsNew As New ClassBinaryExpression
        clsNew.pFirstVarString = pFirstVarString
        clsNew.pOperator = pOperator
        If _firstvar.pKind = ClassVarOrVal.enumvarOrVal.node Then
            clsNew.InitChildList()
            Dim clschild As ClassBinaryExpression

            For i = 0 To _leftchildnodelist.Count - 1
                clschild = _leftchildnodelist(i).CopySelf
                clsNew.pChildList.Add(clschild)
            Next
        ElseIf _firstvar.pKind = ClassVarOrVal.enumvarOrVal.Variable Then
            clsNew.pFirstVar.pValue = _firstvar.pValue
        End If
        Return clsNew
    End Function
    Public Sub InitChildList()
        _leftchildnodelist = New List(Of ClassBinaryExpression)
    End Sub
    Public Property pChildList As List(Of ClassBinaryExpression)
        Get
            Return _leftchildnodelist
        End Get
        Set(value As List(Of ClassBinaryExpression))
            _leftchildnodelist = value
        End Set
    End Property
    Public Property pPriority As Double
        Get
            Return _priority
        End Get
        Set(value As Double)
            _priority = value
        End Set
    End Property
    Public ReadOnly Property pFirstVarSingle As Single
        Get
            Return _firstvar.pValue
        End Get

    End Property
    Public ReadOnly Property pOperatorEnum As enumOperatorTypes
        Get
            Return _operator
        End Get
    End Property
    Public Property pOperator As String
        Get
            Return _operatorStr
        End Get
        Set(value As String)
            _operatorStr = value

            Select Case _operatorStr
                Case "*"
                    _operator = enumOperatorTypes.enumMult
                    _priority = 2
                Case "^", "**"
                    _operator = enumOperatorTypes.enumPower
                    _priority = 3
                Case "+"
                    _operator = enumOperatorTypes.enumAdd
                    _priority = 1
                Case "-"
                    _operator = enumOperatorTypes.enumSubtract
                    _priority = 1
                Case "/"
                    _operator = enumOperatorTypes.enumDivide
                    _priority = 2
                Case "f"
                    _operator = enumOperatorTypes.enumApplyFunction
                    _priority = 4
                    _firstvar.pStr = _firstvar.pStr.ToUpper
                Case Else
                    _operator = enumOperatorTypes.enumNone
                    _priority = 0
            End Select
        End Set
    End Property
    Public Property pFirstVarString As String
        Get
            Return _firstvar.pStr
        End Get
        Set(value As String)
            _firstvar = New ClassVarOrVal
            _firstvar.pStr = value
            If value.Length = 0 Then
                Exit Property
            End If
            Dim i As Integer
            Dim foundletter As Boolean = False
            Dim founddigit As Boolean = False
            Dim firstcharletter As Boolean = False
            Dim letter1 As String
            letter1 = value(0)
            If letter1 = "(" Then
                _firstvar.pKind = ClassVarOrVal.enumvarOrVal.node
                Exit Property
            End If
            For i = 0 To value.Length - 1
                If Char.IsLetter(value(i)) Then
                    foundletter = True
                    If i = 0 Then
                        firstcharletter = True
                    End If
                ElseIf Char.IsDigit(value(i)) Then
                    founddigit = True
                End If
            Next
            If Not foundletter Then
                _firstvar.pKind = ClassVarOrVal.enumvarOrVal.Constant
                If Not Single.TryParse(_firstvar.pStr, _firstvar.pValue) Then
                    Dim ex As New Exception("um valor ilegal de  [" & value & "] foi encontrado na equação")
                    Throw ex
                End If
            ElseIf Not founddigit Then
                _firstvar.pKind = ClassVarOrVal.enumvarOrVal.Variable
            ElseIf firstcharletter Then
                _firstvar.pKind = ClassVarOrVal.enumvarOrVal.Variable
            Else
                Dim ex As New Exception("um valor ilegal de  [" & value & "] foi encontrado na equação")
                Throw ex
            End If
        End Set
    End Property
    Public ReadOnly Property pFirstVar As ClassVarOrVal
        Get
            Return _firstvar
        End Get

    End Property
End Class
