﻿Imports System.Text
Public Class ClassEquation
    Private _equacaoOriginal As String
    Private _equacaoProcessada As String
    Private _listaBinarios As List(Of ClassBinaryExpression)
    Private _nonValoresArray() As Boolean
    Private _parteAntesIgual As String = ""
    Public ReadOnly Property pProcessedEquation As String
        Get
            Return _equacaoProcessada
        End Get

    End Property
    Public ReadOnly Property pPartBeforeEqual As String
        Get
            Return _parteAntesIgual
        End Get
    End Property
    Private Sub AtribuirValoresParaVariaveisRecur(ByRef _argListaDeBinarios As List(Of ClassBinaryExpression))
        Dim i As Integer
        For i = 0 To _argListaDeBinarios.Count - 1
            Select Case _argListaDeBinarios(i).pFirstVar.pKind

                Case ClassVarOrVal.enumvarOrVal.node
                    AtribuirValoresParaVariaveisRecur(_argListaDeBinarios(i).pChildList)
                Case ClassVarOrVal.enumvarOrVal.Variable
                    Dim j As Integer
                    For j = 0 To ClassGlobals.pVarList.Count - 1
                        If ClassGlobals.pVarList(j).pVarName.ToUpper = _argListaDeBinarios(i).pFirstVar.pStr.ToUpper Then
                            _argListaDeBinarios(i).pFirstVar.pValue = ClassGlobals.pVarList(j).pVarValue
                            Exit For
                        End If
                    Next
            End Select
        Next
    End Sub
    Public Sub AssignValuesToVariables()
        AtribuirValoresParaVariaveisRecur(_listaBinarios)
    End Sub
    Public Function CalcularEquacao() As Double
        Dim copyOfList As New List(Of ClassBinaryExpression)
        For i = 0 To _listaBinarios.Count - 1
            copyOfList.Add(_listaBinarios(i).CopySelf)
        Next
        'Dim dummystr As String = printEquationBinaries(copyOfList, 1)
        'MessageBox.Show("dummystr copyoflist is " & dummystr)
        Return CalculaResultadoEquacao(copyOfList)
    End Function
    Private Function CalculaResultadoEquacao(ByRef _argListaDeBinarios As List(Of ClassBinaryExpression)) As Double
        Dim i As Integer
        Dim mustcalcright As Boolean
        Dim mustcalcleft As Boolean
        Dim priority As Integer
        Dim lastindex As Integer

        If _argListaDeBinarios.Count = 1 Then
            If _argListaDeBinarios(0).pFirstVar.pKind = ClassVarOrVal.enumvarOrVal.node Then
                Return CalculaResultadoEquacao(_argListaDeBinarios(0).pChildList)
            Else
                Return _argListaDeBinarios(0).pFirstVar.pValue
            End If
        End If

        lastindex = _argListaDeBinarios.Count - 1
        If _argListaDeBinarios(lastindex).pFirstVar.pKind = ClassVarOrVal.enumvarOrVal.node Then
            _argListaDeBinarios(lastindex).pFirstVar.pValue = CalculaResultadoEquacao(_argListaDeBinarios(lastindex).pChildList)
            _argListaDeBinarios(lastindex).pFirstVar.pKind = ClassVarOrVal.enumvarOrVal.Constant
        End If
        If _argListaDeBinarios(0).pFirstVar.pKind = ClassVarOrVal.enumvarOrVal.node Then
            _argListaDeBinarios(0).pFirstVar.pValue = CalculaResultadoEquacao(_argListaDeBinarios(0).pChildList)
            _argListaDeBinarios(0).pFirstVar.pKind = ClassVarOrVal.enumvarOrVal.Constant
        End If
        Dim localresult As Double
        For priority = 4 To 1 Step -1
            i = 0
            Do While True
                If i = _argListaDeBinarios.Count Then
                    Exit Do
                End If

                If _argListaDeBinarios(i).pPriority = priority Then
                    mustcalcright = True
                    mustcalcleft = True

                    If _argListaDeBinarios(i).pFirstVar.pKind <> ClassVarOrVal.enumvarOrVal.node Then
                        mustcalcleft = False
                    End If
                    If _argListaDeBinarios(i + 1).pFirstVar.pKind <> ClassVarOrVal.enumvarOrVal.node Then
                        mustcalcright = False
                    End If
                    If mustcalcleft Then
                        _argListaDeBinarios(i).pFirstVar.pValue = CalculaResultadoEquacao(_argListaDeBinarios(i).pChildList)
                        _argListaDeBinarios(i).pFirstVar.pKind = ClassVarOrVal.enumvarOrVal.Constant
                    End If
                    If mustcalcright Then
                        _argListaDeBinarios(i + 1).pFirstVar.pValue = CalculaResultadoEquacao(_argListaDeBinarios(i + 1).pChildList)
                        _argListaDeBinarios(i + 1).pFirstVar.pKind = ClassVarOrVal.enumvarOrVal.Constant
                    End If
                    Dim strTranslate As String
                    strTranslate = _argListaDeBinarios(i).TranslateOperator(_argListaDeBinarios(i).pOperatorEnum)
                    localresult = computeBinary(_argListaDeBinarios(i).pFirstVar.pStr, _argListaDeBinarios(i).pFirstVar.pValue,
                                                _argListaDeBinarios(i + 1).pFirstVar.pValue, _argListaDeBinarios(i).pOperatorEnum, strTranslate)
                    _argListaDeBinarios(i).pOperator = _argListaDeBinarios(i + 1).pOperator
                    _argListaDeBinarios.RemoveAt(i + 1)
                    _argListaDeBinarios(i).pFirstVar.pKind = ClassVarOrVal.enumvarOrVal.Constant
                    _argListaDeBinarios(i).pFirstVar.pValue = localresult
                Else
                    i = i + 1
                End If
            Loop
        Next

        Return _argListaDeBinarios(0).pFirstVar.pValue
    End Function
    Private Function computeBinary(ByVal funcname As String, ByVal leftdouble As Double, ByVal rightdouble As Double,
                                   ByVal theop As ClassBinaryExpression.enumOperatorTypes, ByVal opstr As String) As Double
        Dim result As Double
        Dim isfunc As Boolean = False

        Select Case theop
            Case ClassBinaryExpression.enumOperatorTypes.enumAdd
                result = leftdouble + rightdouble
            Case ClassBinaryExpression.enumOperatorTypes.enumSubtract
                result = leftdouble - rightdouble
            Case ClassBinaryExpression.enumOperatorTypes.enumMult
                result = leftdouble * rightdouble
            Case ClassBinaryExpression.enumOperatorTypes.enumDivide
                result = leftdouble / rightdouble
            Case ClassBinaryExpression.enumOperatorTypes.enumPower
                result = leftdouble ^ rightdouble
            Case ClassBinaryExpression.enumOperatorTypes.enumApplyFunction
                isfunc = True
                Select Case funcname
                    Case "ABS"
                        result = Math.Abs(rightdouble)
                    Case "SIGN"
                        result = Math.Sign(rightdouble)
                    Case "SQRT"
                        result = Math.Sqrt(rightdouble)
                    Case "LOG"
                        result = Math.Log(rightdouble)
                    Case "LOG10"
                        result = Math.Log10(rightdouble)
                    Case "EXP"
                        result = Math.Exp(rightdouble)
                    Case "SIN"
                        result = Math.Sin(rightdouble)
                    Case "COS"
                        result = Math.Cos(rightdouble)
                    Case "TAN"
                        result = Math.Tan(rightdouble)
                    Case Else
                        Dim ex As New Exception("You used a function that we have not added to our program: " & funcname)
                        Throw ex
                End Select
            Case Else
                result = 0
        End Select
        If isfunc Then
            If Double.IsInfinity(result) Then
                Dim ex As New Exception("Um valor infinito resultou de " & funcname)
                Throw ex
            End If
            If result = Double.NaN Then
                Dim ex As New Exception("Um valor ilegal foi passado para " & funcname)
                Throw ex
            End If
        Else
            If Double.IsInfinity(result) Then
                Dim ex As New Exception("Um valor resulto de " & opstr.ToUpper)
                Throw ex
            End If
            If result = Double.NaN Then
                Dim ex As New Exception("Um valor ilegal resultou de " & opstr.ToUpper)
                Throw ex
            End If
        End If

        Return result
    End Function
    Public Function printEquation() As String
        Dim sb As New StringBuilder("")
        sb.AppendLine("Equação Original  => " & _equacaoOriginal)
        sb.AppendLine("Versão Processada => " & _equacaoProcessada)
        sb.AppendLine("Versão binária :")
        sb.Append(printEquationBinaries(_listaBinarios, 1))
        Return sb.ToString
    End Function
    Public Function printEquationBinaries(ByRef mylistofbinaries As List(Of ClassBinaryExpression), ByVal level As Integer) As String
        Dim sb As New StringBuilder("")

        Dim i As Integer

        sb.AppendLine("Nível " & level)
        For i = 0 To mylistofbinaries.Count - 1
            sb.Append("nó " & i & ": ")
            sb.Append(mylistofbinaries(i).PrintSelf)
        Next
        For i = 0 To mylistofbinaries.Count - 1
            If mylistofbinaries(i).pFirstVar.pKind = ClassVarOrVal.enumvarOrVal.node Then
                sb.AppendLine("no " & i & " filho: ")   ' i FOR GRANDCHILDREN WOULD NOT WORK
                sb.Append(printEquationBinaries(mylistofbinaries(i).pChildList, level + 1))
            End If
        Next
        Return sb.ToString
    End Function
    Public Property pOriginalEquation As String
        Get
            Return _equacaoOriginal
        End Get
        Set(value As String)
            _equacaoOriginal = value.Trim ' .toupper
            If _equacaoOriginal.Length = 0 Then
                Dim ex As New Exception("Error: sua equação esta em branco.")
                Throw ex
            End If
            _equacaoProcessada = removeblanks(_equacaoOriginal).Replace("+-", "-").Replace("-+", "-")
            Dim lenpe As Integer
            lenpe = _equacaoProcessada.Length

            Dim indexequal As Integer
            indexequal = _equacaoProcessada.IndexOf("=")
            If indexequal = lenpe - 1 Then
                Dim ex As New Exception("Você não pode encerrar uma equação com sinal de igual.")
                Throw ex
            End If
            If indexequal > -1 Then

                _parteAntesIgual = _equacaoProcessada.Substring(0, indexequal)
                _equacaoProcessada = _equacaoProcessada.Substring(indexequal + 1)
            Else
                _parteAntesIgual = String.Empty
            End If
            Dim sb As New StringBuilder("")
            Dim i As Integer
            Dim currentletter As String
            Dim nextletter As String
            i = 0
            If _equacaoProcessada.Length > 1 Then
                currentletter = _equacaoProcessada(i)
                nextletter = _equacaoProcessada(i + 1)
                If currentletter = "-" And Char.IsLetter(nextletter) Then
                    sb.Append("-1*")
                    sb.Append(_equacaoProcessada.Substring(1))
                    _equacaoProcessada = sb.ToString
                End If
            End If
            _nonValoresArray = ClassGlobals.GetNonValues(_equacaoProcessada)

            _listaBinarios = getBinaries(_equacaoProcessada, "pOriginalEquation") ' returns list, so store it in what?
        End Set
    End Property


    Public ReadOnly Property pListOfBinaries As List(Of ClassBinaryExpression)
        Get
            Return _listaBinarios
        End Get
    End Property
    Private Function removeblanks(ByVal instr As String) As String
        Dim sb As New StringBuilder
        Dim i As Integer
        Dim letter As String
        For i = 0 To instr.Length - 1
            letter = instr(i)
            If Char.IsWhiteSpace(letter) Then
                Continue For
            End If
            sb.Append(letter)
        Next
        Return sb.ToString
    End Function
    Private Function getBinaries(ByVal argString As String, ByVal callfrom As String) As List(Of ClassBinaryExpression)
        Dim i As Integer
        Dim start As Integer = 0
        Dim letter As String
        Dim firstpos As Integer
        Dim lastpos As Integer
        Dim haveBrackets As Boolean = False
        Dim havefunction As Boolean = False
        Dim lastposOfArg As Integer
        Dim operatorletter As String
        lastposOfArg = argString.Length - 1
        Dim listOfBinaries = New List(Of ClassBinaryExpression)
        Dim removepair As Boolean
        Dim bracketcount As Integer = 0

        Do While True
            removepair = False
            If argString.Length = 0 Then
                Return listOfBinaries
            End If
            If argString(0) <> "(" Then
                Exit Do
            End If
            If argString(lastposOfArg) <> ")" Then
                Exit Do
            End If
            If argString(lastposOfArg - 1) = ")" And argString(1) = "(" Then
                removepair = True
            Else
                bracketcount = 0
                For i = 1 To argString.Length - 2

                    If argString(i) = "(" Then
                        bracketcount = bracketcount + 1
                    ElseIf argString(i) = ")" Then
                        bracketcount = bracketcount - 1
                    End If
                    If bracketcount < 0 Then
                        removepair = False
                        Exit Do
                    End If
                Next
                If bracketcount = 0 Then
                    removepair = True
                End If
            End If
            If Not removepair Then
                Exit Do
            End If
            argString = argString.Substring(1, lastposOfArg - 1)
            lastposOfArg = argString.Length - 1
        Loop
        Dim nonValuesArray() As Boolean
        nonValuesArray = ClassGlobals.GetNonValues(argString)
        Do While True
            If start > 600 Then
                Dim ex As New Exception("estouro de memória no processamento da equação - verifique...")
                Throw ex
            End If

            Dim sb As New StringBuilder("")
            ' now argString could start and end with brackets, so how handle?
            haveBrackets = False
            havefunction = False
            Dim firstletter As String
            Dim clsB As New ClassBinaryExpression
            firstletter = argString(start)
            If firstletter = "(" Then
                haveBrackets = True
                GetSubExpression(start, firstpos, lastpos, argString)
                start = lastpos + 1
            Else
                haveBrackets = False
                For i = start To lastposOfArg
                    letter = argString(i)
                    If Not nonValuesArray(i) Then
                        sb.Append(letter)
                    ElseIf letter = "(" Then
                        havefunction = True
                        ' start = subexpr, get subexpr, i, start?
                        Exit For
                    Else
                        Exit For
                    End If
                Next
                start = i
            End If

            If haveBrackets Then
                clsB.pFirstVarString = argString.Substring(firstpos, lastpos - firstpos + 1)
                clsB.pChildList = getBinaries(clsB.pFirstVarString, "getBinaries recurses")
            Else
                clsB.pFirstVarString = sb.ToString
                If havefunction Then
                    If Char.IsLetter(firstletter) Then
                        clsB.pFirstVar.pKind = ClassVarOrVal.enumvarOrVal.efunction
                    End If
                End If
            End If

            If start < argString.Length - 1 Then
                operatorletter = argString(start)
                If operatorletter = "(" Then
                    operatorletter = "f"
                    start = start - 1
                End If
                clsB.pOperator = operatorletter ' assumes operator is one character
            End If

            listOfBinaries.Add(clsB)
            start = start + 1
            If start >= argString.Length Then
                Exit Do
            End If
        Loop

        Return listOfBinaries
    End Function


    Private Sub GetSubExpression(ByVal start As Integer, ByRef firstpos As Integer, ByRef lastpos As Integer, ByVal argstring As String)
        Dim contarColchetes As Integer
        Dim letter As String

        Dim j As Integer
        contarColchetes = 0
        firstpos = start
        For j = start To argstring.Length - 1
            letter = argstring(j)
            If letter = "(" Then
                contarColchetes = contarColchetes + 1
            ElseIf letter = ")" Then
                contarColchetes = contarColchetes - 1
                lastpos = j
            End If
            If contarColchetes = 0 Then
                Exit For
            End If
        Next
        If contarColchetes <> 0 Then
            Dim ex As New Exception("Error: existem parenteses não balanceados na equação.")
            Throw ex
        End If
    End Sub

End Class
