﻿Imports System.Text
Public Class ClassGlobals
    Private Shared _equation As String
    Private Shared _clsEq As ClassEquation
    Private Shared _firstform As Form1
    Private Shared _variablesSTRING As String
    Private Shared _varlist As New List(Of ClassVariable)
    Public Shared Property pVarList As List(Of ClassVariable)
        Get
            Return _varlist
        End Get
        Set(value As List(Of ClassVariable))
            _varlist = value
        End Set
    End Property

    Public Shared Property pVariableSTRING As String
        Get
            Return _variablesSTRING
        End Get
        Set(value As String)
            _variablesSTRING = value
        End Set
    End Property
    Public Shared Property pFirstform As Form1
        Get
            Return _firstform
        End Get
        Set(value As Form1)
            _firstform = value
        End Set
    End Property

    Public Shared Property pEquation As String
        Get
            Return _equation
        End Get
        Set(value As String)
            _equation = value
        End Set
    End Property
    Public Shared Property pclsEq As ClassEquation
        Get
            Return _clsEq
        End Get
        Set(value As ClassEquation)
            _clsEq = value
        End Set
    End Property
    Public Shared Function populateVariablesBox(ByVal leaveoutValues As Boolean) As String
        Dim varlistLOCAL As List(Of ClassVariable)
        varlistLOCAL = ClassGlobals.pVarList
        Dim sb As New StringBuilder("")
        If varlistLOCAL.Count > 0 Then

            For i = 0 To varlistLOCAL.Count - 1
                If i > 0 Then
                    sb.Append(",")
                End If
                If leaveoutValues Then
                    sb.Append(varlistLOCAL(i).pVarName & "=?")
                Else
                    sb.Append(varlistLOCAL(i).pVarName & "=" & varlistLOCAL(i).pVarValue)
                End If

            Next
        End If
        Return sb.ToString

    End Function
    Public Shared Function MakeTextIntoVarlist(ByVal strVariaveis As String, ByRef varlist As List(Of ClassVariable), ByRef mensagemErro As String) As Boolean
        mensagemErro = ""
        strVariaveis = strVariaveis.Replace(" ", "")
        Dim pairs() As String
        Dim pairArray(2) As Char
        pairArray(0) = ","
        pairArray(1) = ";"
        pairArray(2) = "|"
        pairs = strVariaveis.Split(pairArray)
        Dim havepairs As Boolean = True
        If pairs.Length = 1 Then
            If pairs(0).Length = 0 Then
                havepairs = False
            End If
        ElseIf pairs.Length = 0 Then
            havepairs = False
        End If
        varlist = New List(Of ClassVariable)
        Dim i As Integer
        If havepairs Then
            Dim equalpos As Integer
            Dim leftstr As String
            Dim rightstr As String
            Dim thepair As String
            Dim pairlength As Integer
            Dim rightval As Double
            For i = 0 To pairs.Length - 1
                thepair = pairs(i)
                pairlength = thepair.Length
                equalpos = thepair.IndexOf("=")
                If equalpos < 0 Then
                    mensagemErro = "Erro: você esqueceu um sinal de igual fora do par da variável " & pairs(i)
                    Return False
                ElseIf equalpos + 1 = pairlength Then
                    mensagemErro = "Erro: voce deixou a parte depois do sinal de igual (o valor) fora do par da variável " & pairs(i)
                    Return False
                End If
                leftstr = thepair.Substring(0, equalpos)
                rightstr = thepair.Substring(equalpos + 1)
                If Not Char.IsLetter(leftstr(0)) Then
                    mensagemErro = "Erro: o nome das variáveis deve iniciar com uma letra em " & pairs(i)
                    Return False
                End If
                If Not Double.TryParse(rightstr, rightval) Then
                    mensagemErro = "Erro: valores (a direita do sinal de igual) devem ser númericos : " & pairs(i)
                    Return False
                End If
                Dim cv As New ClassVariable
                cv.pVarName = leftstr
                cv.pVarValue = rightval
                varlist.Add(cv)
            Next
        End If
        varlist.Sort()
        Return True
    End Function

    Public Shared Function readSingleNum(ByVal filename As String) As Single
        Dim bytearr() As Byte
        bytearr = My.Computer.FileSystem.ReadAllBytes(filename)
        Return BitConverter.ToSingle(bytearr, 0)
    End Function
    Public Shared Sub SaveSingleNum(ByVal filename As String, ByVal theSingle As Single)
        Dim bytearr() As Byte
        bytearr = BitConverter.GetBytes(theSingle)
        My.Computer.FileSystem.WriteAllBytes(filename, bytearr, False)
    End Sub
    Public Shared Function readDoubleNum(ByVal filename As String) As Double
        Dim bytearr() As Byte
        bytearr = My.Computer.FileSystem.ReadAllBytes(filename)
        Return BitConverter.ToDouble(bytearr, 0)
    End Function
    Public Shared Sub SaveDoubleNum(ByVal filename As String, ByVal theDouble As Double)
        Dim bytearr() As Byte
        bytearr = BitConverter.GetBytes(theDouble)
        My.Computer.FileSystem.WriteAllBytes(filename, bytearr, False)
    End Sub
    Public Shared Function readIntegerNum(ByVal filename As String) As Integer
        Dim bytearr() As Byte
        bytearr = My.Computer.FileSystem.ReadAllBytes(filename)
        Return BitConverter.ToInt32(bytearr, 0)
    End Function
    Public Shared Sub SaveIntegerNum(ByVal filename As String, ByVal theInteger As Integer)
        Dim bytearr() As Byte
        bytearr = BitConverter.GetBytes(theInteger)
        My.Computer.FileSystem.WriteAllBytes(filename, bytearr, False)
    End Sub
    Public Shared Function GetVarList(ByVal strEquacao As String) As List(Of ClassVariable)
        Dim i As Integer
        Dim letter As String
        Dim varsb As String
        Dim sb As New StringBuilder("")
        Dim listaVariaveisLocais As New List(Of ClassVariable)
        Dim nonValuesArray(strEquacao.Length - 1) As Boolean

        nonValuesArray = GetNonValues(strEquacao)
        For i = 0 To strEquacao.Length - 1
            letter = strEquacao(i)
            If nonValuesArray(i) Then
                varsb = sb.ToString
                sb.Clear()
                If varsb.Length = 0 Then
                    Continue For
                End If
                If Not Char.IsLetter(varsb(0)) Then
                    Continue For
                End If
                If letter = "(" Then
                    Continue For
                End If
                If VarListaContem(listaVariaveisLocais, varsb) Then
                    Continue For
                End If
                Dim aVar As New ClassVariable
                aVar.pVarName = varsb

                aVar.pVarValue = 0
                listaVariaveisLocais.Add(aVar)
            Else
                sb.Append(letter)
            End If

        Next
        varsb = sb.ToString
        sb.Clear()
        If varsb.Length <> 0 Then

            If Char.IsLetter(varsb(0)) Then
                If Not VarListaContem(listaVariaveisLocais, varsb) Then
                    Dim aVar As New ClassVariable
                    aVar.pVarName = varsb
                    aVar.pVarValue = 0
                    listaVariaveisLocais.Add(aVar)
                End If
            End If
        End If
        listaVariaveisLocais.Sort()
        Return listaVariaveisLocais
    End Function
    Public Shared Function VarListaContem(ByRef listaVariaveisLocais As List(Of ClassVariable), ByVal thestr As String) As Boolean
        Dim i As Integer
        For i = 0 To listaVariaveisLocais.Count - 1
            If listaVariaveisLocais(i).pVarName = thestr Then
                Return True
            End If
        Next
        Return False
    End Function
    Public Shared Function GetNonValues(ByVal argString As String) As Boolean()
        Dim i As Integer
        Dim nonValuesArray(argString.Length - 1) As Boolean
        Dim firstletter As String
        Dim start As Integer = 0

        firstletter = argString(0)
        If firstletter = "+" Or firstletter = "-" Then
            nonValuesArray(0) = False
            start = 1
        End If
        For i = start To argString.Length - 1
            nonValuesArray(i) = False
            If i = 0 Then
                ' note skip unary operator, if we ever put in functions, this skipping of a leter would be a problem
                Continue For
            End If
            Select Case argString(i)
                Case "("
                    nonValuesArray(i) = True
                Case ")"
                    nonValuesArray(i) = True
                Case "+", "-"
                    nonValuesArray(i) = True
                Case "*", "/"
                    nonValuesArray(i) = True
                Case "^"
                    nonValuesArray(i) = True
            End Select
        Next
        Return nonValuesArray
    End Function
    Public Shared Function VariaveisNomesCoincidem(ByRef varlist1 As List(Of ClassVariable), ByRef varlist2 As List(Of ClassVariable)) As Boolean
        Dim i As Integer
        If varlist1.Count <> varlist2.Count Then
            Return False
        End If
        For i = 0 To varlist1.Count - 1
            If varlist1(i).pVarName <> varlist2(i).pVarName Then
                Return False
            End If
        Next
        Return True
    End Function

End Class

