﻿Imports System.Text

Public Class FormVariables

    Private chamadaRetornar As Boolean = False
    Private Sub btnProsseguir_Click(sender As Object, e As EventArgs) Handles btnProsseguir.Click
        Dim strtxtVariaveis As String
        Dim mensagemErro As String = ""
        strtxtVariaveis = Me.txtVariaveis.Text.Trim
        If strtxtVariaveis.Length = 0 Then
            MessageBox.Show("Error: Você não informou nenhum valor.")
            Exit Sub
        End If
        If strtxtVariaveis.Contains("?") Then
            MessageBox.Show("Error: Você não substitui todos os pontos de interrogação.")
            Exit Sub
        End If
        Dim listaVariaveisLocais As New List(Of ClassVariable)
        If Not ClassGlobals.MakeTextIntoVarlist(strtxtVariaveis, listaVariaveisLocais, mensagemErro) Then
            MessageBox.Show(mensagemErro)
            Exit Sub
        End If
        ClassGlobals.pVarList = listaVariaveisLocais
        My.Computer.FileSystem.WriteAllText("variaveis.txt", strtxtVariaveis, False)
        ClassGlobals.pVariableSTRING = strtxtVariaveis
        Me.Hide()
        Form3.Show()
    End Sub
    Private Sub FormVariables_FormClosing(sender As Object, e As FormClosingEventArgs) _
     Handles MyBase.FormClosing
        If chamadaRetornar Then
            chamadaRetornar = False
            Exit Sub
        End If
        If e.CloseReason = CloseReason.UserClosing Then
            Application.Exit()
        End If

    End Sub

    Private Sub FormVariables_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.CenterToScreen()
        Dim mensagemErro As String = ""
        Dim leVariaveisDoArquivo As String = ""
        Dim podeUsarVersaoSalva As Boolean = False
        Dim leListaVariaveisDoArquivo As New List(Of ClassVariable)
        Me.txtEquacao.Text = ClassGlobals.pEquation
        If My.Computer.FileSystem.FileExists("variaveis.txt") Then
            leVariaveisDoArquivo = My.Computer.FileSystem.ReadAllText("variaveis.txt")
            If ClassGlobals.MakeTextIntoVarlist(leVariaveisDoArquivo, leListaVariaveisDoArquivo, mensagemErro) Then
                If ClassGlobals.VariaveisNomesCoincidem(leListaVariaveisDoArquivo, ClassGlobals.pVarList) Then
                    podeUsarVersaoSalva = True
                End If
            End If
        End If
        If podeUsarVersaoSalva Then
            Me.txtVariaveis.Text = leVariaveisDoArquivo
        Else
            Me.txtVariaveis.Text = ClassGlobals.populateVariablesBox(True)
        End If
        Labeltitle.Text = "Atribua os valores às variáveis (substitua os ??? pelos valores)"
    End Sub


    Private Sub btnAjuda_Click(sender As Object, e As EventArgs) Handles btnAjuda.Click
        Dim sb As New StringBuilder("")
        sb.AppendLine("Substitua os pontos de interrogação por valores. Se você informou a equação:  x ^ 2 * C + 5")
        sb.AppendLine("Você deve visualizar os seguintes parâmetros : x=???,C=???")
        sb.AppendLine("Você pode substituir pelos seguintes valores : x=1.5,y=0.7")
        sb.AppendLine("Se (neste exemplo), você quer que x seja o valor que mude, então x é a variável e C é o valor constante")
        sb.AppendLine("Então qualquer valor que você atribuir a 'x' é um valor inicial a partir do qual a iteração começa. No caso de C porém, o valor não será alterado.")
        MessageBox.Show(sb.ToString)
    End Sub

    Private Sub btnRetornar_Click(sender As Object, e As EventArgs) Handles btnRetornar.Click
        chamadaRetornar = True
        Me.Close()
        Form1.Show()
    End Sub


End Class